/*
 * $Id: demo_1.prg 662 2011-07-10 17:45:32Z bcd12a $
*/

/*
 * HMG 4 demo
 * (c) 2010 Roberto Lopez <mail.box.hmg@gmail.com>
*/

#include "hmg.ch"

FUNCTION Main

   LOCAL aRows [10] [3]
   LOCAL oFrame
   LOCAL oFrame1
   LOCAL oFrame2
   LOCAL oButton1
   LOCAL oButton2
   LOCAL oButton3
   LOCAL oTab
   LOCAL oPage1
   LOCAL oPage2
   LOCAL oEditBox1
   LOCAL oProgressbar1
   LOCAL oRadioGroup1
   LOCAL oCheckBox
   LOCAL oCheckBox1
   LOCAL oCombo1
   LOCAL oTextBox
   LOCAL oSpinner
   LOCAL oDatePicker
   LOCAL oSlider
   LOCAL oDial
   LOCAL oScrollBar

   PRIVATE oWindow
   PRIVATE oGrid

   HbQt_ErrorSys()

   aRows [1]    := {'Simpson'  ,'Homer' ,'555-5555'}
   aRows [2]    := {'Mulder'   ,'Fox'   ,'324-6432'}
   aRows [3]    := {'Smart'    ,'Max'   ,'432-5892'}
   aRows [4]    := {'Grillo'   ,'Pepe'  ,'894-2332'}
   aRows [5]    := {'Kirk'     ,'James' ,'346-9873'}
   aRows [6]    := {'Barriga'  ,'Carlos','394-9654'}
   aRows [7]    := {'Flanders' ,'Ned'   ,'435-3211'}
   aRows [8]    := {'Smith'    ,'John'  ,'123-1234'}
   aRows [9]    := {'Pedemonti','Flavio','000-0000'}
   aRows [10]   := {'Gomez'    ,'Juan'  ,'583-4832'}

   HMGAPP():Style( "cleanlooks" )

   WITH OBJECT oWindow := Window():New()
      :Row    := 0
      :Col    := 0
      :Width  := 518
      :Height := 400
      :Title  := 'Widget Styles'
      :Type   := WND_MAIN
      :OnInit := { || oWindow:Center() }

      WITH OBJECT oFrame := Frame():New()
         :Row     := 10
         :Col     := 10
         :Width   := 240
         :Height  := 160
         :Caption := 'Group 1'
      END WITH

      WITH OBJECT oRadioGroup1 := RadioGroup():New()
         :Row     := 30
         :Col     := 20
         :Width   := 200
         :Height  := 100
         :options := {"Radio Button 1","Radio Button 2","Radio Button 3"}
         :Value   := 2
      END WITH

      WITH OBJECT oCheckBox := CheckBox():New()
         :Row      := 140
         :Col      := 20
         :Width    := 100
         :Value    := .T.
         :Caption  := 'CheckBox 1'
      END WITH

      WITH OBJECT oCheckBox1 := CheckBox():New()
         :Row      := 140
         :Col      := 120
         :Width    := 100
         :Value    := .F.
         :Caption  := 'CheckBox 2'
      END WITH

      WITH OBJECT oFrame1 := Frame():New()
         :Row       := 10
         :Col       := 257
         :Width     := 240
         :Height    := 160
         :Caption   := 'Group 2'
      END WITH

      WITH OBJECT oButton2 := Button():New()
         :Row     := 30
         :Col     := 270
         :Width   := 215
         :Caption := 'Button Sample'
      END WITH

      WITH OBJECT oButton3 := Button():New()
         :Row           := 70
         :Col           := 270
         :Width         := 215
         :Caption       := 'Button WITH Left Image'
         :Picture       := 'save.png'
         :PictAlignment := BTN_LEFT
      END WITH

      WITH OBJECT oCombo1 := ComboBox():New()
          :Row    := 110
          :Col    := 270
          :Width  := 150
          :Items  := { "E - Item 1", "D - Item 2", "C - Item 3", "B - Item 4", "A - Item 5" }
          :Value  := 3
      END WITH

      WITH OBJECT oFrame2 := Frame():New()
         :Row      := 180
         :Col      := 257
         :Width    := 240
         :Height   := 176
         :Caption  := 'Group 3'
      END WITH

      WITH OBJECT oTextBox := TextBox():New()
         :Row        := 200
         :Col        := 270
         :Width      := 215
         :Height     := 25
         :Password   := .T.
         :Value      := 'toledo'
      END WITH

      WITH OBJECT oSpinner := Spinner():New()
         :Row        := 230
         :Col        := 270
         :Value      := 5
         :Width      := 215
         :Height     := 25
         :RangeMax   := 10
         :RangeMin   := 1
         :Wrap       := .T.
      END WITH

      WITH OBJECT oDatePicker := DatePicker():New()
         :Row   := 260
         :Col   := 270
         :Width      := 215
         :Height     := 25
         :Value := DATE()
      END WITH

      WITH OBJECT oSlider := Slider():New()
         :Row         := 290
         :Col         := 270
         :Width       := 120
         :Height      := 26
         :Rangemin    := 1
         :Rangemax    := 10
         :Value       := 5
         :Orientation := SLD_HORIZONTAL
      END WITH

      WITH OBJECT oScrollBar := ScrollBar():New()
         :Row         := 320
         :Col         := 270
         :Width       := 120
         :Height      := 20
         :Rangemin    := 1
         :Rangemax    := 100
         :Value       := 50
         :Orientation := SLD_HORIZONTAL
      END WITH

      WITH OBJECT oDial := Dial():New()
         :Row         := 290
         :Col         := 410
         :Width       := 60
         :Height      := 60
         :RangeMin    := 1
         :RangeMax    := 50
         :SingleStep  := 1
         :PageStep    := 15
         :Notch       := .T.
      END WITH

      WITH OBJECT oTab := Tab():New()
         :Row  := 180
         :Col  := 10
         :Width  := 240
         :Height  := 175
         :Position := 0

         WITH OBJECT oPage1 := TabPage():New()
            :Caption := 'Grid'

            WITH OBJECT oGrid := VirtualGrid():New()
               :Row            := 5
               :Col            := 5
               :Width          := 225
               :Height         := 140
               :ColumnWidths   := {150,60,70}
               :ColumnHeaders  := {'Column 1','Column 2','Column 3'}
               :Items          := aRows
               :AllowEdit      := .T.
               :CellNavigation := .T.
               :Value          := { 3 , 2 }
            END WITH

         END WITH

         WITH OBJECT oPage2 := TabPage():New()
            :Caption := 'EditBox'

            WITH OBJECT oEditBox1 := EditBox():New()
               :Row        := 10
               :Col        := 10
               :Width      := 220
               :Height     := 130
               :Value      := 'Hey!!!'
               :ScrollBars := EDB_NONE
               :ToolTip    := 'This is a ToolTip'
            END WITH

         END WITH

      END WITH

      WITH OBJECT oProgressbar1 := Progressbar():New("oProgressbar1")
       :Row         := 367
       :Col         := 120
       :Width       := 380
       :Height      := 26
       :Rangemin    := 1
       :Rangemax    := 100
       :Value       := 0
       :Orientation := PRB_HORIZONTAL
       :Tooltip     := "ProgressBar Horizontal Normal"
      END WITH

      WITH OBJECT oButton1 := Button():New()
         :Row     := 365
         :Col     := 10
         :Caption := 'Start'
         :OnClick := { || ButtonClick() }
      END WITH


   END WITH

   oWindow:Activate()

   oFrame:Release()
   oFrame1:Release()
   oFrame2:Release()
   oButton1:Release()
   oButton2:Release()
   oButton3:Release()
   oTab:Release()
   oPage1:Release()
   oPage2:Release()
   oEditBox1:Release()
   oGrid:Release()
   oProgressbar1:Release()
   oRadioGroup1:Release()
   oCheckBox:Release()
   oCheckBox1:Release()
   oCombo1:Release()
   oTextBox:Release()
   oSpinner:Release()
   oDatePicker:Release()
   oSlider:Release()
   oDial:Release()
   oScrollBar:Release()

   RETURN NIL

/*----------------------------------------------------------------------*/

FUNCTION ButtonClick
   LOCAL n

   FOR n := oWindow:oProgressbar1:Rangemin TO oWindow:oProgressbar1:Rangemax
      oWindow:oProgressbar1:Value := n
      INKEY(.05)
   NEXT

   RETURN NIL